Bug 1689397 - Review Request: trellis - Lattice ECP5 FPGA bitstream creation/analysis/programming tools
Summary: Review Request: trellis - Lattice ECP5 FPGA bitstream creation/analysis/progr...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Robert-André Mauchin
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-03-15 19:50 UTC by Gabriel Somlo
Modified: 2019-04-05 05:10 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-03-29 19:18:39 UTC
zebob.m: fedora-review+


Attachments (Terms of Use)

Description Gabriel Somlo 2019-03-15 19:50:49 UTC
Spec URL: http://www.contrib.andrew.cmu.edu/~somlo/trellis-rpm/trellis.spec

SRPM URL: http://www.contrib.andrew.cmu.edu/~somlo/trellis-rpm/trellis-1.0-0.1.20190315git26d6667.fc28.src.rpm

Description: Project Trellis enables a fully open-source flow for ECP5 FPGAs using Yosys for Verilog synthesis and nextpnr for place and route. Project Trellis provides the device database and tools for bitstream creation.

Fedora Account System Username: somlo

NOTE 1: rpmlint will complain about "nextpnr" being a spelling error -- it's not, nextpnr is an FPGA place-and-route tool that uses trellis as a dependency.

NOTE 2: rpmlint will also issue "binary-or-shlib-defines-rpath" warnings on several binaries shipping with the package. This is intentional, as they all use a private, package-specific shared library installed as a subdirectory of %{_libdir} (i.e., %{_libdir}%{name}/).

Comment 1 Robert-André Mauchin 2019-03-18 19:52:36 UTC
 - %{__rm}, %{__mv}, %{__sed}, %{__mkdir}, %{__install} → rm, mv, sed, mkdir, install -p

(Note the -p here to keep timestamps)

 - Why do you package a dev snapshot while the release is so recent?

 - Not sure what system you're during but all Python packages now must start with either python2 of python3:

Last metadata expiration check: 0:00:42 ago on Mon Mar 18 20:18:35 2019.
No matching package to install: 'python-recommonmark'

# for building docs:
BuildRequires: python3-sphinx-latex
BuildRequires: python3-recommonmark

 - [!]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
     Note: Arch-ed rpms have a total of 59760640 bytes in /usr/share
     trellis-1.0-0.1.20190315git26d6667.fc31.x86_64.rpm:59648000
     See:
     https://fedoraproject.org/wiki/Packaging:ReviewGuidelines#Package_Review_Guidelines

   Could you make anoarch -data subpackage for %{_datadir}/%{name}?


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[-]: Rpath absent or only used for internal libs.
     Note: See rpmlint output
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "ISC License", "Expat License". 711
     files have unknown license. Detailed output of licensecheck in
     /home/bob/packaging/review/trellis/review-trellis/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 798720 bytes in 87 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[-]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in trellis
     , trellis-devel
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[!]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
     Note: Arch-ed rpms have a total of 59760640 bytes in /usr/share
     trellis-1.0-0.1.20190315git26d6667.fc31.x86_64.rpm:59648000
     See:
     https://fedoraproject.org/wiki/Packaging:ReviewGuidelines#Package_Review_Guidelines
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: trellis-1.0-0.1.20190315git26d6667.fc31.x86_64.rpm
          trellis-devel-1.0-0.1.20190315git26d6667.fc31.x86_64.rpm
          trellis-debuginfo-1.0-0.1.20190315git26d6667.fc31.x86_64.rpm
          trellis-debugsource-1.0-0.1.20190315git26d6667.fc31.x86_64.rpm
          trellis-1.0-0.1.20190315git26d6667.fc31.src.rpm
trellis.x86_64: W: spelling-error %description -l en_US nextpnr -> next
trellis.x86_64: E: binary-or-shlib-defines-rpath /usr/bin/ecpmulti ['$ORIGIN/../lib64/trellis']
trellis.x86_64: E: binary-or-shlib-defines-rpath /usr/bin/ecppack ['$ORIGIN/../lib64/trellis']
trellis.x86_64: E: binary-or-shlib-defines-rpath /usr/bin/ecppll ['$ORIGIN/../lib64/trellis']
trellis.x86_64: E: binary-or-shlib-defines-rpath /usr/bin/ecpunpack ['$ORIGIN/../lib64/trellis']
trellis.src: W: spelling-error %description -l en_US nextpnr -> next
5 packages and 0 specfiles checked; 4 errors, 2 warnings.

Comment 2 Gabriel Somlo 2019-03-19 14:34:15 UTC
Thanks for the review!

(In reply to Robert-André Mauchin from comment #1)
>  - %{__rm}, %{__mv}, %{__sed}, %{__mkdir}, %{__install} → rm, mv, sed,
> mkdir, install -p
> 
> (Note the -p here to keep timestamps)

Done.

> 
>  - Why do you package a dev snapshot while the release is so recent?

The database submodule doesn't have a release tag (yet), so I'd have to
grab a snapshot of it regardless. Besides, a few useful commits were
applied right after the release tag was added along the way. The package,
while stable, is still gaining new and very useful features quite
frequently, so I plan on tracking dev snapshots for a while yet before
things slow down.

>  - Not sure what system you're during but all Python packages now must start
> with either python2 of python3:
> 
> Last metadata expiration check: 0:00:42 ago on Mon Mar 18 20:18:35 2019.
> No matching package to install: 'python-recommonmark'
> 
> # for building docs:
> BuildRequires: python3-sphinx-latex
> BuildRequires: python3-recommonmark

OK on python3-recommonmark. However, python3-sphinx-latex only exists in
rawhide. All the way up to (and including) F30, it's simply
"python-sphinx-latex". At least on F28, "BuildRequires python3-sphinx-latex"
returns an "package not found" error during mock build.
 
>  - [!]: Large data in /usr/share should live in a noarch subpackage if
> package
>      is arched.
>      Note: Arch-ed rpms have a total of 59760640 bytes in /usr/share
>      trellis-1.0-0.1.20190315git26d6667.fc31.x86_64.rpm:59648000
>      See:
>     
> https://fedoraproject.org/wiki/Packaging:
> ReviewGuidelines#Package_Review_Guidelines
> 
>    Could you make anoarch -data subpackage for %{_datadir}/%{name}?

Done. See updated spec file at
http://www.contrib.andrew.cmu.edu/~somlo/trellis-rpm/trellis.spec
and the new SRPM at
http://www.contrib.andrew.cmu.edu/~somlo/trellis-rpm/trellis-1.0-0.1.20190319git26d6667.fc28.src.rpm

Comment 3 Robert-André Mauchin 2019-03-19 15:01:39 UTC
LGTM, package approved.

Comment 4 Gwyn Ciesla 2019-03-19 15:38:07 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/trellis

Comment 5 Fedora Update System 2019-03-20 15:54:52 UTC
trellis-1.0-0.1.20190320git26d6667.fc30 has been submitted as an update to Fedora 30. https://bodhi.fedoraproject.org/updates/FEDORA-2019-7c5a44b940

Comment 6 Fedora Update System 2019-03-20 15:55:10 UTC
trellis-1.0-0.1.20190320git26d6667.fc29 has been submitted as an update to Fedora 29. https://bodhi.fedoraproject.org/updates/FEDORA-2019-3c6b434de9

Comment 7 Fedora Update System 2019-03-20 15:55:25 UTC
trellis-1.0-0.1.20190320git26d6667.fc28 has been submitted as an update to Fedora 28. https://bodhi.fedoraproject.org/updates/FEDORA-2019-3787bbd9f4

Comment 8 Fedora Update System 2019-03-20 22:02:34 UTC
trellis-1.0-0.1.20190320git26d6667.fc29 has been pushed to the Fedora 29 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-3c6b434de9

Comment 9 Fedora Update System 2019-03-20 22:18:25 UTC
trellis-1.0-0.1.20190320git26d6667.fc28 has been pushed to the Fedora 28 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-3787bbd9f4

Comment 10 Fedora Update System 2019-03-21 19:12:13 UTC
trellis-1.0-0.1.20190320git26d6667.fc30 has been pushed to the Fedora 30 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-7c5a44b940

Comment 11 Fedora Update System 2019-03-26 17:44:16 UTC
trellis-1.0-0.2.20190326gitf1b1b35.fc29 has been submitted as an update to Fedora 29. https://bodhi.fedoraproject.org/updates/FEDORA-2019-b737c5f42e

Comment 12 Fedora Update System 2019-03-26 17:44:32 UTC
trellis-1.0-0.2.20190326gitf1b1b35.fc28 has been submitted as an update to Fedora 28. https://bodhi.fedoraproject.org/updates/FEDORA-2019-b3828dd2ae

Comment 13 Fedora Update System 2019-03-27 04:11:56 UTC
trellis-1.0-0.2.20190326gitf1b1b35.fc28 has been pushed to the Fedora 28 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-b3828dd2ae

Comment 14 Fedora Update System 2019-03-27 04:34:48 UTC
trellis-1.0-0.2.20190326gitf1b1b35.fc29 has been pushed to the Fedora 29 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-b737c5f42e

Comment 15 Fedora Update System 2019-03-27 13:01:28 UTC
trellis-1.0-0.2.20190327gitf1b1b35.fc29 has been submitted as an update to Fedora 29. https://bodhi.fedoraproject.org/updates/FEDORA-2019-1a7f232c7b

Comment 16 Fedora Update System 2019-03-27 13:01:40 UTC
trellis-1.0-0.2.20190327gitf1b1b35.fc28 has been submitted as an update to Fedora 28. https://bodhi.fedoraproject.org/updates/FEDORA-2019-b411f79c95

Comment 17 Fedora Update System 2019-03-27 19:15:02 UTC
trellis-1.0-0.2.20190327gitf1b1b35.fc28 has been pushed to the Fedora 28 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-b411f79c95

Comment 18 Fedora Update System 2019-03-27 20:01:52 UTC
trellis-1.0-0.2.20190327gitf1b1b35.fc29 has been pushed to the Fedora 29 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-1a7f232c7b

Comment 19 Fedora Update System 2019-03-29 19:18:39 UTC
trellis-1.0-0.1.20190320git26d6667.fc30 has been pushed to the Fedora 30 stable repository. If problems still persist, please make note of it in this bug report.

Comment 20 Fedora Update System 2019-04-05 01:55:06 UTC
trellis-1.0-0.2.20190327gitf1b1b35.fc28 has been pushed to the Fedora 28 stable repository. If problems still persist, please make note of it in this bug report.

Comment 21 Fedora Update System 2019-04-05 05:10:07 UTC
trellis-1.0-0.2.20190327gitf1b1b35.fc29 has been pushed to the Fedora 29 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.